%define aurox_ver 10.0
%define rel 1




## $Id: fedora-usermgmt.spec,v 1.9 2004/03/20 01:53:42 ensc Exp $

%define pkgdatadir	%_datadir/%name
%define confdir		%_sysconfdir/fedora/usermgmt
%define alternatives	/usr/sbin/update-alternatives

Summary:	Fedora tools for user management
Name:		fedora-usermgmt
Version:	0.7
Release: %{aurox_ver}.aur.%{rel}
Epoch:		0
License:	GPL
BuildArch:	noarch
Group:		Applications/System
URL:		http://www.fedora.us/wiki/PackageUserCreation
Source0:	fedora-usermgmt-wrapper
Source1:	fedora-usermgmt-README
Requires(pre):	instance(fedora-usermgmt)
Requires(pre):	setup(fedora-usermgmt)
BuildRoot:	%_tmppath/%name-%version-%release-root
Requires(pre):		%_sysconfdir/fedora
Requires(postun):	%_sysconfdir/fedora


%package setup
Summary:	Default values for baseuid/basegid
Group:		System Environment/Base
Provides:	setup(fedora-usermgmt)
Provides:	flavor(fedora-usermgmt-setup) = default
Conflicts:	flavor(fedora-usermgmt-setup) < default
Conflicts:	flavor(fedora-usermgmt-setup) > default
Source2:	fedora-usermgmt-baseid


%package shadow-utils
Summary:	shadow-utils customization for fedora-usermgmt
Group:		Applications/System
Source10:	fedora-usermgmt-groupadd
Source11:	fedora-usermgmt-useradd
Source20:	fedora-usermgmt-groupadd.legacy
Source21:	fedora-usermgmt-useradd.legacy
Provides:	instance(fedora-usermgmt)
Requires:	%name = %epoch:%version-%release
Requires(pre):		%confdir
Requires(postun):	%confdir
Requires(post):		%alternatives
Requires(preun):	%alternatives
Requires:		shadow-utils


%description
This package provides wrapper around the useradd/-del and groupadd/-del
programs to allow predictable uids/gids.


%description setup
This package contains default values for the base of relative UIDs. It
is designed to be overridden by local customizations; you should create
a package with

| Provides:	setup(fedora-usermgmt)
| Provides:	flavor(fedora-usermgmt-setup) = <one-word-description>

put it into your installation tree, remove the fedora-usermgmt-setup
package from there and update the package metainformation (e.g. with
genhdlist, yum-arch, or apt's genbasedir). A separate repository in
combination with apt pinning might be a solution also.


%description shadow-utils
This package provides the customization of fedora-usermgmt for the
traditional shadow-utils.

WARNING: The attribute "predictable" from "predicatable user-creation"
is turned off by default. It can be enabled by executing

  %alternatives --set %name %confdir/scripts.shadow-utils

as root.


%prep
%setup -q -T -c

%__install -p -m644 %SOURCE1 README


%install
rm -rf $RPM_BUILD_ROOT

%__install -d -m755 $RPM_BUILD_ROOT{%pkgdatadir,%confdir,%_sbindir}

## The base package
%__install -p -m755 %SOURCE0 ${RPM_BUILD_ROOT}%pkgdatadir/wrapper
%__install -p -m644 %SOURCE2 ${RPM_BUILD_ROOT}%confdir/baseuid
%__install -p -m644 %SOURCE2 ${RPM_BUILD_ROOT}%confdir/basegid
for i in {user,group}{del,add}; do
	ln -s %pkgdatadir/wrapper ${RPM_BUILD_ROOT}%_sbindir/fedora-$i
done

## The -shadow-utils installation
%__install -d -m755 ${RPM_BUILD_ROOT}%confdir/scripts.{shadow-utils,legacy}
%__install -p -m755 %SOURCE10 ${RPM_BUILD_ROOT}%confdir/scripts.shadow-utils/groupadd
%__install -p -m755 %SOURCE11 ${RPM_BUILD_ROOT}%confdir/scripts.shadow-utils/useradd

%__install -p -m755 %SOURCE20 ${RPM_BUILD_ROOT}%confdir/scripts.legacy/groupadd
%__install -p -m755 %SOURCE21 ${RPM_BUILD_ROOT}%confdir/scripts.legacy/useradd


%post shadow-utils
%alternatives --install %confdir/scripts %name %confdir/scripts.legacy 60
%alternatives --install %confdir/scripts %name %confdir/scripts.shadow-utils 50


%preun shadow-utils
test "$1" != 0 || %alternatives --remove %name %confdir/scripts.shadow-utils
test "$1" != 0 || %alternatives --remove %name %confdir/scripts.legacy


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc README
%dir %_sysconfdir/fedora
%pkgdatadir
%_sbindir/*


%files setup
%defattr(-,root,root,-)
%dir %confdir
%config(noreplace) %confdir/base*
## Temporary hack: /etc/fedora should be provided by a filesystem-like
## package
%dir %_sysconfdir/fedora


%files shadow-utils
%defattr(-,root,root,-)
%dir %confdir/scripts.*
%config %confdir/scripts.*/*


%changelog
* Wed Jul 21 2004 Aurox Team <aurox@aurox.org> 0:0.7-10.0.aur.1
- required by clamav

* Sat Mar 20 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.7-0.fdr.2
- applied patch from https://bugzilla.fedora.us/show_bug.cgi?id=701#c10
  I should not defer such things but apply them immediatly...

* Sat Mar 20 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.7-0.fdr.1
- added some '(Pre)' modifiers to ensure correct installation when a
  package has 'Requires: fedora-usermgmt'
- removed the '%%dir %%confdir' from the main-package, it causes apt
  to fail because of dependency loops; this is not really correct
  since -setup (which owns %%confdir) is a virtual package and other
  instances might missing it
- split the double Requires(...,...): statements; see
  https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=118773
- added support for logging: when /etc/fedora/usermgmt/log exists, every
  output of the commands will be redirected into this file. Usually it
  is not a regular file but a symlink somewhere into /var/log

* Sat Nov  8 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.6-0.fdr.1
- removed duplicate '--help' handling in useradd script
- own /etc/fedora by the -setup subpackage, and require this dir in the
  main-package. This is a temporary hack to avoid orphaned directories
  and related problems; final solution will be that /etc/fedora is
  owned by a filesystem-like basepackage.

* Sun Nov  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5-0.fdr.1
- added basic sanity checks and '--help' to wrapper-scripts
- tied -shadow-utils to main-package
- use %%_sysconfdir instead of /etc
- fixed typos in README (thanks to Michael Schwendt)

* Wed Sep 24 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.4-0.fdr.1
- added -setup subpackage to allow customization of baseuid/gid at
  installation-time

* Fri Sep 12 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.2-0.fdr.91
- moved the skin-scripts into /etc/fedora/usermgmt/scripts.$SKIN
- disable the new, predictable behavior by default
- use 'alternatives' concept

* Fri Sep 12 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.2-0.fdr.1
- fixed *del cases
- renamed spec-file to fedora-usermgmt.spec
- updated doc

* Fri Sep 12 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.1-1
- Initial build.
